﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.ComponentModel;
using Infragistics.Windows.DataPresenter;
using Infragistics.Windows.Editors;
using Infragistics.Windows;

namespace xamDataGridFieldChooserStyle
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window,  INotifyPropertyChanged
    {
        public ObservableCollection<Person> coll { get; set; }
       
        
        public MainWindow()
        {
            InitializeComponent();
            coll = new ObservableCollection<Person>();

            coll.Add(new Person() { Id = 1, LastName = "Doe", Age = 30, Field1="1", Field2="2", Field3="3", Field4="4", Field5="5", Field6="6", Field7="7", Field8="8", Field9="9", Field10="10" });
            coll.Add(new Person() { Id = 2, LastName = "Doe", Age = 30, Field1 = "1", Field2 = "2", Field3 = "3", Field4 = "4", Field5 = "5", Field6 = "6", Field7 = "7", Field8 = "8", Field9 = "9", Field10 = "10" });
            coll.Add(new Person() { Id = 3, LastName = "Doe", Age = 30, Field1 = "1", Field2 = "2", Field3 = "3", Field4 = "4", Field5 = "5", Field6 = "6", Field7 = "7", Field8 = "8", Field9 = "9", Field10 = "10" });
            coll.Add(new Person() { Id = 4, LastName = "Smith", Age = 30, Field1 = "1", Field2 = "2", Field3 = "3", Field4 = "4", Field5 = "5", Field6 = "6", Field7 = "7", Field8 = "8", Field9 = "9", Field10 = "10" });

            xamDataGrid1.DataContext = coll;
        }
        private void XamCheckEditor_ValueChanged(object sender, RoutedPropertyChangedEventArgs<object> e)
        {
            XamCheckEditor editor = sender as XamCheckEditor;
            editor.EndEditMode(true, true);
            if ((bool)e.NewValue == false)
            {
                FieldChooser chooser = Utilities.GetAncestorFromType((sender as DependencyObject), typeof(FieldChooser), false) as FieldChooser;
                if (chooser != null)
                {
                    CheckBox selectAll = Utilities.GetDescendantFromName(chooser, "SelectAllCheckBox") as CheckBox;
                    if (selectAll != null)
                    {
                        selectAll.IsChecked = null;
                    }
                }
            }
            
            
        }
        private void xamDataGrid1_FieldChooserOpening(object sender, Infragistics.Windows.DataPresenter.Events.FieldChooserOpeningEventArgs e)
        {
            
            e.FieldChooser.Style = this.Resources["CustomFieldChooseStyle"] as Style;
            e.FieldChooser.FieldGroupSelectorVisibility = Visibility.Visible;
           
        }

        private void CheckBox_Checked(object sender, RoutedEventArgs e)
        {
            foreach (var item in xamDataGrid1.FieldLayouts[0].Fields)
            {
                item.Visibility = System.Windows.Visibility.Visible;
            }                
        }

        private void CheckBox_Unchecked(object sender, RoutedEventArgs e)
        {
            foreach (var item in xamDataGrid1.FieldLayouts[0].Fields)
            {
                item.Visibility = System.Windows.Visibility.Collapsed;
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }
    }

    public class Person : INotifyPropertyChanged
    {
        private int id;

        public int Id
        {
            get { return id; }
            set
            {
                id = value;
                NotifyPropertyChanged("Id");
            }
        }

        private int age;

        public int Age
        {
            get { return age; }
            set { age = value; NotifyPropertyChanged("Age"); }
        }

        private String lastName;

        public String LastName
        {
            get { return lastName; }
            set { lastName = value; NotifyPropertyChanged("LastName"); }
        }

        private String field1;

        public String Field1
        {
            get { return field1; }
            set { field1 = value; NotifyPropertyChanged("Field1"); }
        }

        private String field2;

        public String Field2
        {
            get { return field2; }
            set { field2 = value; NotifyPropertyChanged("Field2"); }
        }

        private String field3;

        public String Field3
        {
            get { return field3; }
            set { field3= value; NotifyPropertyChanged("Field3"); }
        }

        private String field4;

        public String Field4
        {
            get { return field4; }
            set { field4 = value; NotifyPropertyChanged("Field4"); }
        }

        private String field5;

        public String Field5
        {
            get { return field5; }
            set { field5 = value; NotifyPropertyChanged("Field5"); }
        }

        private String field6;

        public String Field6
        {
            get { return field6; }
            set { field6 = value; NotifyPropertyChanged("Field6"); }
        }

        private String field7;

        public String Field7
        {
            get { return field7; }
            set { field7 = value; NotifyPropertyChanged("Field7"); }
        }

        private String field8;

        public String Field8
        {
            get { return field8; }
            set { field8 = value; NotifyPropertyChanged("Field8"); }
        }

        private String field9;

        public String Field9
        {
            get { return field9; }
            set { field9 = value; NotifyPropertyChanged("Field9"); }
        }

        private String field10;

        public String Field10
        {
            get { return field10; }
            set { field10 = value; NotifyPropertyChanged("Field10"); }
        }



        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }

    }
}
